#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include "tk.h"
#include <errno.h>

int sdopen( ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int port,i;static int sd;static char ans[10];
   if (argc<3) {interp->result="Usage: sdopen address port";
                 return TCL_ERROR;};
   i=sscanf(argv[2],"%d",&port);
   if (i<=0) {interp->result="Usage: sdopen address port";
                 return TCL_ERROR;};
   sd=doconnect(argv[1],port);
   if (i==-1) {interp->result="sdopen: Unable to connect";
                 return TCL_ERROR;};
   sprintf(ans,"file%d",sd);
   interp->result=ans;
   if (argc==4) fcntl(sd,F_SETFL,O_NONBLOCK);
   return TCL_OK;
}
int sdwrite( ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int sd,i;
   if (argc<3) {interp->result="Usage: sdwrite fd string (zero)";
                 return TCL_ERROR;};
   i=sscanf(argv[1],"file%d",&sd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};
   i=write(sd,argv[2],strlen(argv[2])+argc-3);
   if (i==0) {interp->result="Write to EOF"; return TCL_OK;};
   if (i==-1) {sprintf(interp->result, "Write Error %d",errno);
               return TCL_ERROR; };
   return TCL_OK;
}
char answer[1000];
int sdread( ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int sd,i;
   answer[0]=0;
   if (argc!=2) {interp->result="Usage: sdread fd ";
                 return TCL_ERROR;};
   i=sscanf(argv[1],"file%d",&sd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};
   i=read(sd,answer,995); 
   if ((i<0)&&(errno!=EAGAIN)){
   sprintf(interp->result, "Read Error %d",errno);
   return TCL_ERROR;};
   if (i>=0) answer[i]=0;
   interp->result=answer;
   return TCL_OK;

}
int sdclose( ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int sd,i;
   if (argc!=2) {interp->result="Usage: sdclose fd ";
                 return TCL_ERROR;};
   i=sscanf(argv[1],"file%d",&sd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};
   close(sd);
   return TCL_OK;
}
int sdpoll( ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int sd,i;
   if (argc!=2) {interp->result="Usage: sdpoll fd ";
                 return TCL_ERROR;};
   i=sscanf(argv[1],"file%d",&sd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};
  { 
    fd_set in_fdset;
    int retval;
    struct itimerval value;
      value.it_value.tv_usec = 10;
      value.it_value.tv_sec = 0;
    FD_ZERO(&in_fdset);
    FD_SET(sd,&in_fdset);
    retval = select(1,&in_fdset,NULL,NULL,&value.it_value);  
    interp->result=answer;
    sprintf(answer,"%d",(FD_ISSET(sd,&in_fdset))); 
    return TCL_OK;
  }
}
extern void runcommand(),gettoken(),getanswer();
lib134Init(Tcl_Interp *interp)    
    {Tcl_CreateCommand(interp,"sdopen",(Tcl_CmdProc *)sdopen, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"sdwrite",(Tcl_CmdProc *)sdwrite, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"sdread",(Tcl_CmdProc *)sdread, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"sdclose",(Tcl_CmdProc *)sdclose, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"sdpoll",(Tcl_CmdProc *)sdpoll, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"runcommand",(Tcl_CmdProc *)runcommand, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"gettoken",(Tcl_CmdProc *)gettoken, (ClientData) 0,NULL);
    Tcl_CreateCommand(interp,"getanswer",(Tcl_CmdProc *)getanswer, (ClientData) 0,NULL);
}
/* These are all the new commands in lib1;
sdopen, sdclose, sdwrite, sdread, sdpoll, runcommand, gettoken, getanswer
 
the external variables so far are elsewhere. */







